'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var apolloServerExpress = require('apollo-server-express');
var bodyParser = _interopDefault(require('body-parser'));
var program = _interopDefault(require('commander'));
var express = _interopDefault(require('express'));
var fs = _interopDefault(require('fs'));
var lunarCore = require('lunar-core');

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
}

const toFunction = str => Function.call(null, `return ${str}`)();

const serialize = body => Object.entries(body).reduce((acc, [key, value]) => Object.assign({}, acc, {
  [key]: value.toString()
}), {});
const deserialize = body => Object.entries(body).reduce((acc, [key, value]) => Object.assign({}, acc, {
  [key]: toFunction(value)
}), {});
function index () {
  return _ref.apply(this, arguments);
}

function _ref() {
  _ref = _asyncToGenerator(function* () {
    program.version('0.0.2', '-v, --version').usage('[options] <file ...>').option('-p, --port <port>').parse(process.argv);

    const port = program.port,
          _program$args = _slicedToArray(program.args, 1),
          file = _program$args[0];

    const schema = apolloServerExpress.makeExecutableSchema({
      typeDefs: fs.readFileSync(file, 'utf8')
    });
    const currentMocks = [{}];
    const app = express();
    const server = new apolloServerExpress.ApolloServer({
      schema
    });
    app.use(bodyParser.json());
    app.get('/', (req, res) => res.json({
      port,
      schema
    }));
    app.post('/mock', (req, res) => {
      currentMocks.push(deserialize(req.body));
      lunarCore.addMockFunctionsToSchema({
        schema,
        mocks: currentMocks
      });
      res.sendStatus(200);
    });
    app.post('/reset', (req, res) => {
      currentMocks.splice(1, currentMocks.length);
      lunarCore.removeMockFunctionsFromSchema({
        schema
      });
      lunarCore.addMockFunctionsToSchema({
        schema,
        mocks: {}
      });
      res.sendStatus(200);
    });
    server.applyMiddleware({
      app
    });
    app.listen({
      port
    }, () => {
      console.log(`🐬  GraphQL Mock Server running at http://localhost:${port}`);
    });
  });
  return _ref.apply(this, arguments);
}

exports.serialize = serialize;
exports.deserialize = deserialize;
exports.default = index;
